<?php

namespace Drupal\sqrl\Controller;

use Drupal\Core\Access\AccessResult;
use Drupal\user\Entity\User;

/**
 * Provides the SQRL unlink controller.
 */
class Unlink extends Link {

  /**
   * @param \Drupal\user\Entity\User $user
   *
   * @return \Drupal\Core\Access\AccessResult
   */
  public function access(User $user): AccessResult {
    if ($this->currentUser->isAuthenticated() && $this->currentUser->id() === $user->id()) {
      // TODO: Check if the user has an identity.
      return AccessResult::allowed();
    }
    return AccessResult::forbidden();
  }

  /**
   * @param User $user
   *
   * @return array
   */
  public function request(User $user): array {
    // TODO: Implement this feature.
    return [
      '#markup' => 'Not yet implemented.',
    ];
  }

}
