<?php

namespace Drupal\sqrl\Plugin\SqrlAction;

use Drupal\Core\Entity\EntityStorageException;
use Drupal\sqrl\Entity\Identity;
use Drupal\sqrl\SqrlActionPluginBase;

/**
 * Plugin implementation of the sqrl action "setkey".
 *
 * @SqrlAction(
 *   id = "setkey",
 *   label = @Translation("Set key"),
 *   description = @Translation("TBD.")
 * )
 */
class SetKey extends SqrlActionPluginBase {

  /**
   * {@inheritdoc}
   */
  public function run(): bool {
    if (!$this->user) {
      return FALSE;
    }
    if ($this->getIdentityByIdk()) {
      // Nothing changed and we have nothing to do.
      return TRUE;
    }
    /*
     * TODO: implement the extra identity.
    if (!$additional) {
      // Remove the current key, we are getting a new one.
      db_delete('sqrl_user')
        ->condition('uid', $this->user->uid)
        ->condition('idk', $client->hash_pubkey($client->get_client_var('pidk')))
        ->execute();
    }
    */

    $identity = Identity::create([
      'idk' => $this->client->getClientVar('idk'),
      'suk' => $this->client->getClientVar('suk'),
      'vuk' => $this->client->getClientVar('vuk'),
      'uid'  => $this->user->id(),
      'status' => TRUE,
    ]);

    try {
      if ($identity->save()) {
        $this->client->setResponse('suk', $this->client->getClientVar('suk'));
        $this->client->setResponse('vuk', $this->client->getClientVar('vuk'));
        return TRUE;
      }
    } catch (EntityStorageException $e) {
    }
    return FALSE;
  }

}
