<?php

namespace Drupal\sqrl\Routing;

use Drupal\Core\Config\ConfigFactoryInterface;
use Drupal\Core\Routing\RouteSubscriberBase;
use Drupal\sqrl\Form\Settings;
use Symfony\Component\Routing\RouteCollection;

/**
 * Listens to the dynamic route events.
 */
class Subscriber extends RouteSubscriberBase {

  /**
   * @var \Drupal\Core\Config\Config
   */
  protected $config;

  /**
   * {@inheritdoc}
   */
  public function __construct(ConfigFactoryInterface $config_factory) {
    $this->config = $config_factory->get('sqrl.settings');
  }

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    if ($this->config->get('mode') === Settings::MODE_EXCLUSIVE) {
      $routeIds = [
        'user.pass',
        'user.pass.http',
        'user.reset.form',
      ];
      foreach ($routeIds as $routeId) {
        if ($route = $collection->get($routeId)) {
          $route->setRequirement('_access', 'FALSE');
        }
      }
    }
  }

}
