<?php

namespace Drupal\sqrl;

use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\user\Entity\User;

/**
 * Interface for sqrl_action plugins.
 */
interface SqrlActionInterface extends ContainerFactoryPluginInterface {

  /**
   * Returns the translated plugin label.
   *
   * @return string
   *   The translated title.
   */
  public function label(): string;

  /**
   * @return bool
   */
  public function run(): bool;

  /**
   * @param \Drupal\user\Entity\User|NULL $user
   *
   * @return $this
   */
  public function setUser(User $user = NULL): SqrlActionInterface;

  /**
   * @return $this
   */
  public function rememberSuccess(): SqrlActionInterface;

}
